library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_signed.all;

entity compito is
	port ( din: in std_logic_vector(15 downto 0);
	clk, rst, esegui: in std_logic;
	ris: out std_logic_vector(15 downto 0);
	fine: out std_logic );
end compito;

architecture beh of compito is
type stati is (idle,letop,decodifica, letd1shl,letd1or,exeshl,exeor,execnt,exepar);
signal st,nst: stati;
signal op: std_logic_vector(1 downto 0);
signal no_fine: std_logic;
signal d0,d1: std_logic_vector(15 downto 0);
signal enop,end0,end1,enshl,enor,encnt,enpar: std_logic;
signal conta: integer range 0 to 1;
begin
process(rst,clk)
begin
	if rst = '1' then st <= idle;
	elsif clk'event and clk='0' then 
		st <= nst;  -- aggiorna lo stato con lo stato prossimo;
	end if;
end process;

process(st, op, no_fine,esegui)
begin
	case st is
		when idle => if esegui = '1' then nst <= letop;
		             else nst <= idle;
					 end if;
		when letop => nst <= decodifica;
		when decodifica => -- decodifica
					case op is
					 when "00" => nst <= letd1shl;
					 when "01" => nst <= letd1or;
					 when "10" => nst <= execnt;
					 when "11" => nst <= exepar;
					 when others => nst <= idle;
				   end case;
		when letd1shl => nst <= exeshl;
		when letd1or => nst <= exeor;
		when exeshl => if no_fine = '1' then nst <=  exeshl;
		               else nst <= idle;
					   end if;
		when exepar => if no_fine = '1' then nst <=  exepar;
		               else nst <= idle;
					   end if; 			   
		when others => nst <= idle;
	end case;
end process;

 enop <= '1' when st = letop  else '0';
 end0 <= '1' when st = decodifica  else '0';
 end1 <= '1'  when st = letd1shl or st = letd1or else '0';
 enshl <= '1' when st = exeshl else '0';
 enor <= '1' when st = exeor else '0';
 encnt <= '1' when st = execnt else '0';
 enpar <= '1' when st = exepar else '0';
	 
 no_fine <= '1' when (enshl ='1' and conta=0) or (enpar ='1' and conta = 0) else '0';

process(clk)  
variable num: integer range 0 to 16;
begin
	if clk'event and clk='0' then
		if enop ='1' then op<= din(1 downto 0);
			conta<=0;
	    end if;
		
		if end0 = '1' then d0 <= din;
		end if;
		if end1 = '1' then d1 <= din;
		end if;
		if enor = '1' then ris <= d0 or d1;
		end if;
		if encnt = '1' then
			num:=0;
			for i in 0 to 15 loop
				if d0(i) = '1' then num := num+1;
				end if;
			end loop;
			ris <= conv_std_logic_vector(num,16);
		end if;
		if enshl ='1' then
			if no_fine= '0' then
				ris <= shl(d0,d1);
	 		else conta <= 1;
		   end if;
		end if;
		
		if enpar = '1' then 
			if no_fine= '0' then
			  num:=0;
			  for i in 0 to 15 loop
				if d0(i) = '1' then num := num+1;
				end if;
			  end loop;
			  ris <= conv_std_logic_vector(num mod 2, 16);
			else conta <= 1;
			end if;	
		  end if;
		  
		fine <= enor or encnt or ((enshl or enpar) and not no_fine); 
     end if;
	end process;
end beh;
	


